import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Demarrage extends JFrame implements ActionListener{
	Cadre cadre;
  BorderLayout borderLayout1 = new BorderLayout();
  JList jList1 = new JList(Logo.path);
  JScrollPane scroll=new JScrollPane(jList1);
  JPanel jPanel1 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField jTextField1 = new JTextField();
  BorderLayout borderLayout2 = new BorderLayout();
  ButtonGroup groupe = new ButtonGroup();
  JButton jButton2 = new JButton();
  JButton jButton1 = new JButton();
  JPanel jPanel2 = new JPanel();
  JButton jButton3 = new JButton();
  JButton jButton4 = new JButton();;
   
	JPanel p_executer=new JPanel();
	BorderLayout borderexec = new BorderLayout();
	JLabel exec=new JLabel(" "+Logo.messages.getString("procedure_demarrage")+" ");
	JTextField proc_demarrage=new JTextField();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  public Demarrage(Cadre cadre) throws HeadlessException {
		this.cadre=cadre;
    setTitle(Logo.messages.getString("definir_demarrage"));
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
		setFont(Logo.police);
		jList1.setFont(Logo.police);
		jButton1.setFont(Logo.police);
		jButton2.setFont(Logo.police);
		jButton3.setFont(Logo.police);
		jButton4.setFont(Logo.police);
		jLabel1.setFont(Logo.police);
		jTextField1.setFont(Logo.police);
		exec.setFont(Logo.police);
    this.getContentPane().setLayout(borderLayout1);
    jList1.setOpaque(true);
    jLabel1.setText(Logo.messages.getString("chemin")+" ");
    jPanel1.setLayout(borderLayout2);
    
		jButton4.setText(Logo.messages.getString("ok"));
    jButton2.setText(Logo.messages.getString("ajouter"));
    jButton1.setText(Logo.messages.getString("parcourir"));
    jButton3.setText(Logo.messages.getString("enlever"));
    jPanel2.setLayout(gridBagLayout1);
    this.getContentPane().add(scroll,  BorderLayout.CENTER);
    this.getContentPane().add(jPanel1,  BorderLayout.NORTH);
    jPanel1.add(jTextField1, BorderLayout.CENTER);
    jPanel1.add(jLabel1,  BorderLayout.WEST);
    this.getContentPane().add(jPanel2,  BorderLayout.EAST);
	jPanel2.add(jButton4,    new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
				,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    jPanel2.add(jButton3,    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    jPanel2.add(jButton2,     new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    jPanel2.add(jButton1,    new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
         p_executer.setLayout(borderexec);
         p_executer.add(proc_demarrage,BorderLayout.CENTER);
         p_executer.add(exec,BorderLayout.WEST);
         this.getContentPane().add(p_executer,BorderLayout.SOUTH);
        jButton1.addActionListener(this);
        jButton1.setActionCommand(Logo.messages.getString("parcourir"));
        jButton2.addActionListener(this);
        jButton2.setActionCommand(Logo.messages.getString("ajouter"));
        jButton3.addActionListener(this);
        jButton3.setActionCommand(Logo.messages.getString("enlever"));
		jButton4.addActionListener(this);
		jButton4.setActionCommand(Logo.messages.getString("ok"));
        jTextField1.addActionListener(this);
        if (!Logo.a_executer.equals("# aucun")) proc_demarrage.setText(Logo.a_executer);
      this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    }
	protected void processWindowEvent(WindowEvent e){
		if (e.getID()==WindowEvent.WINDOW_CLOSING){
			this.toFront();  	
		}
	}

  public void actionPerformed(ActionEvent e){
    if (e.getActionCommand().equals(Logo.messages.getString("parcourir"))){
      JFileChooser jf=new JFileChooser();
      jf.addChoosableFileFilter(new ExtensionFichier(Logo.messages.getString("fichiers_logo"),".lgo"));
			MenuListener.recursivelySetFonts(jf,Logo.police);
      int retval=jf.showDialog(this,Logo.messages.getString("ouvrir"));
      if (retval==JFileChooser.APPROVE_OPTION){
       jTextField1.setText(jf.getSelectedFile().getAbsolutePath());
      }
    }
    else if (e.getActionCommand().equals(Logo.messages.getString("enlever"))){    //Enlever
      if (!Logo.path.isEmpty()){
        int index=Logo.path.search(jList1.getSelectedValue());
        if (index!=-1){
          Logo.path.removeElementAt(Logo.path.size()-index);
          jList1.setListData(Logo.path);
        }
      }
    }
	if (e.getActionCommand().equals(Logo.messages.getString("ok"))){
		String texte=proc_demarrage.getText().trim();
		if (texte.equals("")) Logo.a_executer="# aucun";
		else Logo.a_executer=texte;
		dispose();
	}
    else {  // Si on valide ou si on appuie sur le bouton ajouter

      String text=jTextField1.getText().trim();
      if (Logo.path.search(text)==-1&&!text.equals("")) Logo.path.push(text);
      jList1.setListData(Logo.path);
      jTextField1.setText("");
    }
  }
}