import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

public class Panneau_Coloration extends JPanel implements ActionListener {
	Combo_Couleur p_comment;
	Combo_Couleur p_parenthese;
	Combo_Couleur p_primitive;
	Combo_Couleur p_operande;
	private GridBagLayout gb = new GridBagLayout();
	private JTextPane jt=new JTextPane();
	private DocumentLogo dsd;
	private JCheckBox active_coloration = new JCheckBox();
	private JLabel l_active=new JLabel();
	private JButton bdefaut=new JButton();
	Panneau_Coloration(){
		l_active.setFont(Logo.police);
		l_active.setText(Logo.messages.getString("activer_coloration"));
		bdefaut.setFont(Logo.police);
		bdefaut.setText(Logo.messages.getString("par_defaut"));
		setLayout(gb);
        jt.setOpaque(true);
        jt.setBackground(Color.white);
        dsd=new DocumentLogo();
        jt.setDocument(dsd);
        dsd.setColore_Parenthese(true);
		p_comment=new Combo_Couleur(Logo.coloration_commentaire,Logo.style_commentaire,Logo.messages.getString("style_commentaire"),this);;
		p_parenthese=new Combo_Couleur(Logo.coloration_parenthese,Logo.style_parenthese,Logo.messages.getString("style_parenthese"),this);;
		p_primitive=new Combo_Couleur(Logo.coloration_primitive,Logo.style_primitive,Logo.messages.getString("style_primitive"),this);;
		p_operande=new Combo_Couleur(Logo.coloration_operande,Logo.style_operande,Logo.messages.getString("style_operande"),this);;
		jt.setText(Logo.messages.getString("exemple_coloration"));
		if (Logo.COLOR_ENABLED) active_coloration.setSelected(true);
		else {
			active_coloration.setSelected(false);
			p_comment.setEnabled(false);
			p_primitive.setEnabled(false);
			p_parenthese.setEnabled(false);
			p_operande.setEnabled(false);
			bdefaut.setEnabled(false);	
		} 
        add(active_coloration, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(
						5, 10, 5, 10), 0, 0));
        add(l_active, new GridBagConstraints(1, 0, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(
						5, 10, 5, 10), 0, 0));
        add(p_comment, new GridBagConstraints(0, 1, 3, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						5, 10, 5, 10), 0, 0));
        add(p_primitive, new GridBagConstraints(0, 2, 3, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						5, 10, 5, 10), 0, 0));
        add(p_operande, new GridBagConstraints(0, 3, 3, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						5, 10, 5, 10), 0, 0));
        add(p_parenthese, new GridBagConstraints(0, 4, 3, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						5, 10, 5, 10), 0, 0));
        add(jt, new GridBagConstraints(0, 5, 3, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						10, 10, 10, 10), 0, 0));
        add(bdefaut, new GridBagConstraints(0, 6, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(
						10, 10, 10, 10), 0, 0));
        active_coloration.addActionListener(this);
        active_coloration.setActionCommand("checkbox");
        bdefaut.addActionListener(this);
        bdefaut.setActionCommand("bouton");
	}
	
	boolean Coloration_activee(){
		return active_coloration.isSelected();
	}
	
	public void actionPerformed(ActionEvent e){
		String cmd=e.getActionCommand();
		if (cmd.equals("checkbox")){
			if (p_comment.isEnabled()){
				p_comment.setEnabled(false);
				p_primitive.setEnabled(false);
				p_parenthese.setEnabled(false);
				p_operande.setEnabled(false);
				bdefaut.setEnabled(false);
				dsd.setColoration(false);
				jt.setText(Logo.messages.getString("exemple_coloration"));
			}
			else {
				p_comment.setEnabled(true);
				p_primitive.setEnabled(true);
				p_parenthese.setEnabled(true);
				p_operande.setEnabled(true);
				bdefaut.setEnabled(true);
				dsd.setColoration(true);
				rafraichis_texte();
			}
		}
		else if (cmd.equals("bouton")){
			p_comment.setColorAndStyle(Color.GRAY.getRGB(),Font.PLAIN);
			p_parenthese.setColorAndStyle(Color.RED.getRGB(),Font.BOLD);
			p_primitive.setColorAndStyle(new Color(0,128,0).getRGB(),Font.PLAIN);
			p_operande.setColorAndStyle(Color.BLUE.getRGB(),Font.PLAIN);
			rafraichis_texte();
		}
		
	}
	public void rafraichis_texte(){
		dsd.initStyles(p_comment.color(),p_comment.style(),p_primitive.color(),p_primitive.style(),
				p_parenthese.color(),p_parenthese.style(),p_operande.color(),p_operande.style());
		jt.setText(Logo.messages.getString("exemple_coloration"));
		dsd.initStyles(Logo.coloration_commentaire,Logo.style_commentaire,Logo.coloration_primitive,Logo.style_primitive,
				Logo.coloration_parenthese,Logo.style_parenthese,Logo.coloration_operande,Logo.style_operande);

	}
}
